/**
 * Create API reporter function, that accepts object and sends it to `url`
 * using `navigator.sendBeackon` when avaiable or fallbacks back to XMLHttpRequest.
 *
 * The function is debounced by default, so it can acummulate object values
 * and send every `wait` time or `maxWait` if the events keep coming.
 *
 * Use `onSend` argument to implement a custom logic.
 *
 * @param {string} url
 * @param {{ initial?: object, beforeSend?: function, onSend?: function }} [opts]
 * @return {(metrics: object) => void}
 */
export function createApiReporter(url: string, opts?: {
    initial?: any;
    beforeSend?: Function | undefined;
    onSend?: Function | undefined;
} | undefined): (metrics: any) => void;
