/**
 * Get device information.
 * - Effective connection type: https://developer.mozilla.org/en-US/docs/Web/API/NetworkInformation
 * - Device memory in GB rounded to 2: https://developer.mozilla.org/en-US/docs/Web/API/Navigator/deviceMemory
 */
export function getDeviceInfo(): {
    url: string | undefined;
    referrer: string | undefined;
    userAgent: string | undefined;
    memory: number | undefined;
    cpus: number | undefined;
    connection: {
        effectiveType: "slow-2g" | "2g" | "3g" | "4g";
        rtt: number;
        downlink: number;
    } | undefined;
};
